; 
    include masm32rt.inc
    .586                        ; necessary for timers
    include timers.asm

    time MACRO definition
      sz SIZESTR <definition>
      instruction SUBSTR <definition>,2,sz-2
      counter_begin LOOP_COUNT,HIGH_PRIORITY_CLASS
        REPEAT REPEAT_COUNT + 1 ; added 1 to correct count
          instruction
        ENDM
      counter_end
      mov   ebx,eax
      print chr$(definition," : ")
      print ustr$(ebx)
      print chr$(" cycles",13,10)
      invoke Sleep,250
    ENDM
; 
    .data
    .code
; 
start:
; 
    LOOP_COUNT    EQU 10000000
    REPEAT_COUNT  EQU 100

    adc ecx,ebx
    adc edx,eax
    
    print "clocks per 100 instructions:",13,10,13,10
    time "nop                    "
    time "mov eax,0              "
    time "mov eax,ecx            "
    time "xor eax,eax            "
    time "sub ecx,ecx            "
    time "and ecx,0              "
    time "add ecx,1              "
    time "inc ecx                "
    time "mov edi,edi            "
    time "shl ecx,2              "
    time "lea ecx,[4*ecx]        "
    time "lea edx,[4*ecx]        " ; eliminate dependency?
    time "shl ecx,3              "
    time "lea ecx,[8*ecx]        "
    time "lea edx,[8*ecx]        " ; eliminate dependency?
    time "add ecx,ebx            "
    time "adc ecx,ebx            "
    time "db 13h,0cbh,13h,0d0h   " ; adc ecx,ebx adc edx,eax

    mov   eax, input(13,10,"Press enter to exit...")
    exit
; 
end start
